; ----------------------------------------------------------------------------
; RetroForth Release Series 8
; Version 3
; ----------------------------------------------------------------------------
include "../rx/rx.macros"

format elf executable
entry main

main:
	pop dword [arg_count]
	pop dword [args]
	call bootstrap_rx

	upsh linux_boot
	upsh [linux_boot.size]
	call eval

	upsh [args]
	upsh [arg_count]

	upsh linux_postboot
	upsh [linux_postboot.size]
	call eval

	jmp boot

arg_count dd 0
args	  dd 0
;---------------------------------------------------------------------
code 'syscall', _syscall

       ; syscalls can take a variable number of arguments, from 0 to 6.
       ; The args go in ebx, ecx, edx, esi, edi, ebp, in that order.
       ; (this is from the Linux Assembly HOWTO)

       ; At entry, the Forth stack holds args, argcount, syscall-number

       ; validate argcount, if > 6 return without changing the stack
           cmp dword [esi], 6
           jbe lsc_ok
           ret
lsc_ok:                             ; do a swap on the data stack
           push eax
           mov eax, [esi]
           pop dword [esi]         ; swapped eax=argcount

           mov [lsc_rsp], esp      ; save current return stack
           mov esp, esi            ; now point return stack to data stack
           dec eax                 ; adjust and set s flag
           js  lsc_0               ;   if 0 jump to first index
           mov eax, [lsc_tbl+eax*4]    ; index into jump table
           jmp eax

           ; entered the pop statements individually for clarity.

lsc_0:      pop eax
           jmp lsc_m
lsc_1:      pop eax
           pop ebx
           jmp lsc_m
lsc_2:      pop eax
           pop ebx
           pop ecx
           jmp lsc_m
lsc_3:      pop eax
           pop ebx
           pop ecx
           pop edx
           jmp lsc_m
lsc_4:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           jmp lsc_m
lsc_5:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           pop edi
           jmp lsc_m
lsc_6:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           pop edi
           pop ebp
           ;  fall through
lsc_m:      int 80h
           mov esi, esp            ; restore adjusted data stack
           mov esp, [lsc_rsp]      ; restore the return stack
           ret

lsc_rsp:   dd 0
lsc_tbl:   dd lsc_1
           dd lsc_2
           dd lsc_3
           dd lsc_4
           dd lsc_5
           dd lsc_6
; syscall interface ends here
;---------------------------------------------------------------------
linux_boot:
	file "forth/io.forth"
	include "../modules.inc"
.size	dd $-linux_boot

linux_postboot:
	file "forth/cmdline.forth"
.size	dd $-linux_postboot

;---------------------------------------------------------------------
include "../rx/rx.asm"
