inline
: dup [ $fc4689 3, $fc768d 3, ] ;
: 1+ [ $40 1, ] ;
: 1- [ $48 1, ] ;
: swap [ $0687 2, ] ;
: drop [ $ad 1, ] ;
: nip [ $04c683 3, ] ;
: 2drop [ $adad 2, ] ;
: and [ $0623 2, ] nip ;
: or [ $060b 2, ] nip ;
: xor [ $0633 2, ] nip ;

forth
: not -1 xor ;
: @ [ $008b 2, ] ;
: ! [ $adc289 3, $ad0289 3, ] ;
: w@ @ $ffff and ;
: w! [ $adc289 3, $ad028966 , ] ;
: c@ @ $ff and ;
: c! [ $adc289 3, $ad0288 3, ] ;

: + [ $0603 2, ] nip ;
: * [ $26f7 2, ] nip ;
: - [ $ad0629 3, ] ;
: negate -1 * ;
: /mod [ $c389 2, $99ad 2, $fbf7 2, ] dup [ $d089 2, ] swap ;
: / /mod nip ;
: mod /mod drop ;
 
: wsparse 32 parse ;
: lnparse 10 parse ;
: '? wsparse find ;
: ' '? drop ;
: >> [ $c189 2, $d3ad 2, $e8 1, ] ;
: << [ $c189 2, $d3ad 2, $e0 1, ] ;
: here h0 @ ;

: :link       ;
: :xt     4 + ;
: :class  8 + ;
: :name  12 + ;

: reclass last @ :class ! ;
: reclass: class @ ' drop  which @ :class ! ;

macro
: x:  ' compile ;
: ['] ' x: literal ;
: c: x: ['] ['] compile compile ;

: as ' x: literal c: reclass ;

: >r $ad50 2, ;
: r> c: dup $58 1, ;
: r x: r> $50 1, ;
: rdrop $5b 1, ;
 
: repeat here ;
: again compile x: ;; ;
: next x: r> $48 1, $8f0f 2, here - 4 - , $ad 1, ;
: for here x: >r ;
 
: (if) $063b 2, $adad 2, 2, here 0 , ;
: <>if $840f x: (if) ;
: =if  $850f x: (if) ;
: <if  $8e0f x: (if) ;
: >if  $8d0f x: (if) ;
: if   0 x: literal x: <>if ;
: then dup here swap - 4 - swap ! $90 1, ;
: ;then x: ;; x: then ;
: if; x: if x: ;then ;
 
: prior last @ >r last @ @ last ! ' compile r> last ! ;
: vector $90909090 , $90 1, ;

forth
: cells 4 * ;
: cell+ 4 + ;
: cell- 4 - ;
: word+ 2 + ;
: word- 2 - ;

: rot >r swap r> swap ;
: -rot swap >r swap r> ;
: over >r dup r> swap ;
: tuck dup -rot ;
: 2dup over over ;
 
: later r> r> swap >r >r ;
: 0; dup 0 =if rdrop drop then ;
: execute >r ;

: create: wsparse entry ;
: literal, x: literal ;

: create create: as .data ;
: variable 0 : variable: create , ;
: constant create last @ cell+ ! ;

: +! dup @ rot + swap ! ;
: -! dup @ rot - swap ! ;
: allot h0 +! ;
 
: :: here ] ;
: alias create: last @ cell+ ! ;

create list 5 cells allot
: loc: 1 list +! list @ cells list + last @ swap ! ;
: ;loc list @ cells list + @ last ! 1 list -! ;
 
: fill swap for swap 2dup c! 1+ swap next 2drop ;
: move for swap 2dup c@ swap c! 1+ swap 1+ next 2drop ;
: place dup >r swap move r> ;
: pad here 1024 + ;
: >pad dup 0; >r pad place r> ;

: " '" parse >pad ;

: devector  $90909090 ' $90 over c! 1+ ! ;
loc:
  : change-vector here swap h0 ! swap compile x: ;; h0 ! ;
  : make-entry    entry x: vector compile x: ;; ;
 :: '? if change-vector ;then make-entry ;
;loc alias is

loc:
  : .string dup r> + dup >r over - swap ;
 :: dup literal, dup >r here 5 + place drop c: .string r> allot ;
;loc is $,

macro
: s"  " $, ;
: {  '} parse $, c: eval ;

forth
: hex     16 base ! ;
: decimal 10 base ! ;
: binary   2 base ! ;
: octal    8 base ! ;

: >entry last repeat @ 0; 2dup cell+ @ =if nip ;then again ;
: count  1+ dup 1- c@ ;

 0 constant false
-1 constant true

loc:
  variable size
  : make  dup -rot here place swap dup allot 0 1, 1+ size +! ;
  : free  size @ negate allot 0 size ! ;
 :: make  later free ;
;loc is zt

macro
: ~ vector later ;

forth
loc:
  variable a
  variable b
  : ;voc    b @ a @ last @ swap ! last ! ;
  : .vocab  last @ swap dup @ last ! a ! b ! later ;voc ;
 :: create  last @ , as .vocab ;
;loc is voc:

: get-class dup >entry 2dup =if drop ['] .forth ;then :class @ ;
reset
